<template>
  <div class="payment">
    <b-card
      class="selectedDate text-secondary mb-3"
      bg-variant="light">
      <b class="selectedDate-title">What you have choosen</b>
      <div class="mt-2 mb-1">
        <b>Check-in: </b>
        {{ checkIn }}
      </div>
      <div class="mb-1">
        <b>Check-out: </b>
        {{ checkOut }}
      </div>
      <div class="mb-1">
        <b>Room: </b>
        <span class="capital">{{ roomType }}</span>
      </div>
      <div>
        <b>Room View: </b>
        <span class="capital">{{ roomView }}</span>
      </div>
    </b-card>
    <div class="creditCard mb-3">
      <img
        class="creditCard-image"
        src="@/assets/credit-card.png">
      <div class="creditCard-text cardHolderName">{{ cardHolderName }}</div>
      <div class="creditCard-text exp">EXP: {{ formattedExpDate }}</div>
      <div class="creditCard-text cardNumber">{{ formattedCardNumber }}</div>
    </div>
    <b-row>
      <b-col sm="12" md="5">
        <div class="mb-3">
          <b-form-group label="Card Holder's Name" label-for="cardHolderName">
            <b-form-input
              :value="cardHolderName"
              v-validate="'required|alpha_spaces'"
              id="cardHolderName"
              name="cardHolderName"
              type="text"
              placeholder="Enter your name"
              data-vv-as="Card Holder's Name"
              :state="errors.has('cardHolderName') ? false : null"
              @input="value => $emit('setCardHolderName', value)" />
            <b-form-invalid-feedback id="cardHolderName-feedback">
              {{ errors.first('cardHolderName') }}
            </b-form-invalid-feedback>
          </b-form-group>
        </div>
        <div class="mb-3">
          <b-form-group label="Card Number" label-for="cardNumber">
            <b-form-input
              :value="cardNumber"
              v-validate="'required|numeric|length:16'"
              id="cardNumber"
              name="cardNumber"
              data-vv-as="Card Number"
              type="number"
              placeholder="Enter a Card number"
              :state="errors.has('cardNumber') ? false : null"
              @input="value => $emit('setCardNumber', value)" />
            <b-form-invalid-feedback id="cardNumber-feedback">
              {{ errors.first('cardNumber') }}
            </b-form-invalid-feedback>
          </b-form-group>
        </div>
        <div>
          <b-row>
            <b-col cols="6">
              <b-form-group
                label="Exp Date Month"
                label-for="expDateMonth">
                <b-form-select
                  v-validate="'required'"
                  id="expDateMonth"
                  :value="expDateMonth"
                  name="expDateMonth"
                  data-vv-as="Exp Date Month"
                  :options="months"
                  :state="errors.has('expDateMonth') ? false : null"
                  @change="value => $emit('setExpDateMonth', value)" />
                <b-form-invalid-feedback id="expDateMonth-feedback">
                  {{ errors.first('expDateMonth') }}
                </b-form-invalid-feedback>
              </b-form-group>
            </b-col>
            <b-col cols="6">
              <b-form-group
                label="Exp Date Year"
                label-for="expDateYear">
                <b-form-select
                  v-validate="'required'"
                  id="expDateYear"
                  :value="expDateYear"
                  name="expDateYear"
                  data-vv-as="Exp Date Year"
                  :options="years"
                  :state="errors.has('expDateYear') ? false : null"
                  @change="value => $emit('setExpDateYear', value)" />
                <b-form-invalid-feedback id="expDateYear-feedback">
                  {{ errors.first('expDateYear') }}
                </b-form-invalid-feedback>
              </b-form-group>
            </b-col>
          </b-row>
        </div>
        <div>
          <b-form-group
            label="CVC"
            label-for="cvc">
            <b-form-input
              :value="cvc"
              v-validate="'required|numeric|length:3'"
              id="cvc"
              name="cvc"
              data-vv-as="CVC"
              type="number"
              placeholder="Enter a CVC number"
              :state="errors.has('cvc') ? false : null"
              @input="value => $emit('setCVC', value)" />
            <b-form-invalid-feedback id="cvc-feedback">
              {{ errors.first('cvc') }}
            </b-form-invalid-feedback>
          </b-form-group>
        </div>
      </b-col>
    </b-row>
  </div>
</template>

<script>
export default {
  data () {
    return {
      months: ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'],
      years: ['2020', '2021', '2022', '2023', '2024']
    }
  },

  props: {
    roomType: {
      type: String,
      required: true
    },
    roomView: {
      type: String,
      required: true
    },
    checkIn: {
      type: String,
      required: true
    },
    checkOut: {
      type: String,
      required: true
    },
    cardHolderName: {
      type: String,
      required: true
    },
    cardNumber: {
      type: String,
      required: true
    },
    expDateMonth: {
      type: String,
      required: true
    },
    expDateYear: {
      type: String,
      required: true
    },
    cvc: {
      type: String,
      required: true
    }
  },

  computed: {
    formattedCardNumber () {
      return this.cardNumber.replace(/\d{4}(?=.)/g, '$& ')
    },
    formattedExpDate () {
      let month = '--'
      let year = '--'

      if (this.expDateMonth.length !== 0) {
        month = this.expDateMonth
      }

      if (this.expDateYear.length !== 0) {
        year = this.expDateYear.substring(2, 4)
      }

      return `${month}/${year}`
    }
  }
}
</script>

<style scoped>
.capital {
  text-transform: capitalize;
}
.creditCard {
  position: relative;
}
.creditCard-image {
  width: 320px;
}
.creditCard-text {
  position: absolute;
  font-weight: bold;
  overflow: hidden;
  white-space: nowrap;
}
.cardHolderName {
  top: 105px;
  left: 84px;
  font-size: 13px;
  color: #5b5b5b;
  width: 120px;
  text-overflow: ellipsis;
  text-transform: uppercase;
}
.exp {
  top: 140px;
  left: 84px;
  font-size: 13px;
  color: #5b5b5b;
  }
.cardNumber {
  top: 175px;
  left: 84px;
  font-size: 18px;
  color: #fff;
  text-shadow: 0 1px 1px black;
  letter-spacing: 1px;
  width: 195px;
}
</style>
